' This class is "generated" and will be overwritten.
' Your customizations should be made in TblRoleRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="TblRoleRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="TblRoleTable"></see> class.
''' </remarks>
''' <seealso cref="TblRoleTable"></seealso>
''' <seealso cref="TblRoleRecord"></seealso>

<Serializable()> Public Class BaseTblRoleRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As TblRoleTable = TblRoleTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub TblRoleRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim TblRoleRec As TblRoleRecord = CType(sender,TblRoleRecord)
        Validate_Inserting()
        If Not TblRoleRec Is Nothing AndAlso Not TblRoleRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub TblRoleRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim TblRoleRec As TblRoleRecord = CType(sender,TblRoleRecord)
        Validate_Updating()
        If Not TblRoleRec Is Nothing AndAlso Not TblRoleRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub TblRoleRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim TblRoleRec As TblRoleRecord = CType(sender,TblRoleRecord)
        If Not TblRoleRec Is Nothing AndAlso Not TblRoleRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's TblRole_.RoleId field.
	''' </summary>
	Public Function GetRoleIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.RoleIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's TblRole_.RoleId field.
	''' </summary>
	Public Function GetRoleIdFieldValue() As Byte
		Return CType(Me.GetValue(TableUtils.RoleIdColumn).ToByte(), Byte)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's TblRole_.Role field.
	''' </summary>
	Public Function GetRoleValue() As ColumnValue
		Return Me.GetValue(TableUtils.RoleColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's TblRole_.Role field.
	''' </summary>
	Public Function GetRoleFieldValue() As String
		Return CType(Me.GetValue(TableUtils.RoleColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's TblRole_.Role field.
	''' </summary>
	Public Sub SetRoleFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RoleColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's TblRole_.Role field.
	''' </summary>
	Public Sub SetRoleFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RoleColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's TblRole_.RoleId field.
	''' </summary>
	Public Property RoleId() As Byte
		Get 
			Return CType(Me.GetValue(TableUtils.RoleIdColumn).ToByte(), Byte)
		End Get
		Set (ByVal val As Byte) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.RoleIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RoleIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RoleIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RoleIdDefault() As String
        Get
            Return TableUtils.RoleIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's TblRole_.Role field.
	''' </summary>
	Public Property Role() As String
		Get 
			Return CType(Me.GetValue(TableUtils.RoleColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.RoleColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RoleSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RoleColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RoleDefault() As String
        Get
            Return TableUtils.RoleColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
